package interfejsy;

public class Interfejsy {

    public static void main(String[] args) {
        // Obiekty myszka i kot deklarujemy jako typ Organizm,
        Organizm mysz = new Mysz(5);
        Organizm kot = new Kot();
        // Wywołujemy metody, są one zaimpementowane w różny sposób
        // w klasie Mysz i Kot
        System.out.println("Myszka je: " + mysz.jedz());
        System.out.println("Kot je: " + mysz.jedz());
        mysz.rosnij(1.2);
        kot.rosnij(10.0);        
        Organizm kotek = kot.rozmnozSie();
        
        // To się nie uda, interfejs Organizm nie 
        // ma zadeklarowanej metody piszcz()
        // myszka.piszcz();
        
        // Teraz deklarujemy obiekt jako typ Mysz...
        Mysz myszka = new Mysz(6);
        // ... więc widzi on metodę piszcz()
        myszka.piszcz();
        
        // Stosujemy kasting z typu Organizm na Mysz
        Mysz mycha = (Mysz) mysz.rozmnozSie();
        mycha.piszcz();
        
        nakarmOrganizm(mysz);
        nakarmOrganizm(kot);
        
        System.out.println("Materiał genetyczny myszy to " + 
                            myszka.MATERIAL_GENETYCZNY);
        // w interfejsie pola są statyczne, nie musimy ich 
        // wywoływać z obiektów
        System.out.println("Liczba rodzajów nukeotydów = " +
                            Genetyczny.RODZAJE_NUKLEOTYDOW);
        String[] sekwencja = {"A","C","C","A","G","A","G","G"};
        myszka.wyswietlSekwencje(sekwencja);
        
        mycha.kopNore();
        
        // też da się, choć niekoniecznie ma sens
        kot.kopNore();

    }
    
    static public void nakarmOrganizm(Organizm stworzenie) {
        stworzenie.jedz();
    }
    
}
